﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_datagridview_calculate_color_column
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Make some data items.
            dgvValues.Rows.Add(new object[] { "Pencils, dozen", 1.24m, 4 });
            dgvValues.Rows.Add(new object[] { "Paper, ream", 3.75m, 3 });
            dgvValues.Rows.Add(new object[] { "Cookies, box", 2.17m, 12 });
            dgvValues.Rows.Add(new object[] { "Notebook", 1.95m, 2 });
            dgvValues.Rows.Add(new object[] { "Pencil sharpener", 12.95m, 1 });
            dgvValues.Rows.Add(new object[] { "Paper clips, 100", 0.75m, 1 });

            // Define a column style at run time.
            DataGridViewCellStyle cell_style = new DataGridViewCellStyle();
            cell_style.BackColor = Color.LightGreen;
            cell_style.Alignment = DataGridViewContentAlignment.MiddleRight;
            cell_style.Format = "C2";
            dgvValues.Columns[3].DefaultCellStyle = cell_style;

            // Calculate totals.
            CalculateTotals();
        }

        // Calculate the total costs and highlight totals greater than $9.99.
        private void CalculateTotals()
        {
            // Make a style for values greater than $9.99.
            DataGridViewCellStyle highlight_style = new DataGridViewCellStyle();
            highlight_style.ForeColor = Color.Red;
            highlight_style.BackColor = Color.Yellow;
            highlight_style.Font = new Font(dgvValues.Font, FontStyle.Bold);

            // Calculate the total costs.
            foreach (DataGridViewRow row in dgvValues.Rows)
            {
                // Calculate total cost.
                decimal total_cost =
                    (decimal)row.Cells["PriceEach"].Value *
                    (int)row.Cells["Quantity"].Value;

                // Display the value.
                row.Cells["Total"].Value = total_cost;

                // Highlight the cell if the vcalue is big.
                if (total_cost > 9.99m) row.Cells["Total"].Style = highlight_style;
            }
        }
    }
}
